/*
	RemotingService.as
	Lee Felarca
	http://www.zeropointnine.com/blog
	1-2009
		
	Source code licensed under a Creative Commons Attribution 3.0 License.
	http://creativecommons.org/licenses/by/3.0/
	Some Rights Reserved.
*/

package leelib.remoting
{
	import flash.display.*;
	import flash.events.EventDispatcher;
	import flash.events.NetStatusEvent;
	import flash.net.NetConnection;
	import flash.net.ObjectEncoding;
	import flash.net.Responder;
	import flash.net.registerClassAlias;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;


	public class RemotingService extends EventDispatcher
	{
		public static const GATEWAY_URL:String = "http://localhost/amfphp/gateway.php";
		
		private var _nc:NetConnection;
		private var _responder:Responder
		 
	    public function RemotingService()
	    {
			registerClassAlias("leelib.remoting.RemotingVo", RemotingVo);			
	    }

		private function getClass($instance:*):Class
		{
			trace(getQualifiedClassName($instance));
			
			return getDefinitionByName(getQualifiedClassName($instance)) as Class
		}
		private function registerDefaultClassAlias($instance:*):void
		{
			registerClassAlias(getQualifiedClassName($instance), getClass($instance));
		}


		public function call($serviceName:String, ... $rest):void
		{
			_nc = new NetConnection();
	        _nc.objectEncoding = ObjectEncoding.AMF3;
	        _nc.connect(GATEWAY_URL);
			_responder = new Responder(onResult, onFault);
			_nc.addEventListener(NetStatusEvent.NET_STATUS, onNetStatusEvent, false,0,true);

			switch ($rest.length)
			{
				case 0: _nc.call( $serviceName, _responder, $rest[0]); break;
				case 1: _nc.call( $serviceName, _responder, $rest[0], $rest[1]); break;
				case 2: _nc.call( $serviceName, _responder, $rest[0], $rest[1], $rest[2]); break;
				case 3: _nc.call( $serviceName, _responder, $rest[0], $rest[1], $rest[2], $rest[3]); break;
				case 4: _nc.call( $serviceName, _responder, $rest[0], $rest[1], $rest[2], $rest[3], $rest[4]); break;
				case 5: _nc.call( $serviceName, _responder, $rest[0], $rest[1], $rest[2], $rest[3], $rest[4], $rest[5]); break;
			}
			
			if ($rest.length > 5) throw new Error("No.");
		}

		protected function onResult($vo:RemotingVo):void
		{
			_responder = null;
			_nc.removeEventListener(NetStatusEvent.NET_STATUS, onNetStatusEvent);

			trace('onResult', ($vo) ? $vo.result : "null!");
			this.dispatchEvent(new RemotingEvent($vo.result, $vo.description, $vo.object));
		}

		protected function onFault($fault:Object):void
		{
			_responder = null;
			_nc.removeEventListener(NetStatusEvent.NET_STATUS, onNetStatusEvent);

			trace('onFault:');
			for (var s:String in $fault) trace('-', s, $fault[s]);
			
			this.dispatchEvent(new RemotingEvent("error", $fault.description, null));
		}
		
		protected function onNetStatusEvent($e:NetStatusEvent):void
		{
			_responder = null;
			_nc.removeEventListener(NetStatusEvent.NET_STATUS, onNetStatusEvent);

			var infoCode:String = $e.info.code; 

			trace('onNetStatusEvent:', infoCode);

			this.dispatchEvent(new RemotingEvent("error", "NetStatusEvent:" + infoCode, null));
		}
	}
}
